/*
    hashSum
    Copyright (C) 2011-2016 Ingemar Ceicer
    http://ceicer.org/
    programmering1 (at) ceicer (dot) org

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
*/


#include "checkforupdates.h"
#include "hash.h"





void CheckForUpdates::check(std::string sprak)
{
    if (sprak == "sv_SE")
        applicationHomepage = APPLICATION_HOMEPAGE;
    else
        applicationHomepage = APPLICATION_HOMEPAGE_ENG;

    QUrl url(VERSION_PATH);
    QNetworkAccessManager *nam = new QNetworkAccessManager(this);
    reply = nam->get(QNetworkRequest(url));


    QObject::connect(nam, SIGNAL(finished(QNetworkReply*)),this, SLOT(checkForUpdates(QNetworkReply*)));


}

void CheckForUpdates::checkForUpdates(QNetworkReply *reply)
{
    QByteArray bytes = reply->readAll();  // bytes
    QString version = (QString) bytes; // string
    version = version.trimmed();

    if (version == "")
        QMessageBox::critical(this,APPLICATION_NAME " " VERSION, tr("No Internet connection was found.\nPlease check your Internet settings and firewall."));
    else
   {

	   int ver = jfrVersion(version);

		switch (ver)
	   {
		   case 0:
            QMessageBox::information(this,APPLICATION_NAME " " VERSION, tr("\nThere is a later version of ")+ APPLICATION_NAME + "<br>"+tr("Please download from")+"<p><a href=\"" + applicationHomepage + "\">" + applicationHomepage + "</a></p><p>"+tr("Latest version: ")+version+"</p>");
			break;
		   case 1:
           QMessageBox::information(this,APPLICATION_NAME " " VERSION, tr("\nYour version of ")+ APPLICATION_NAME+tr(" is later than the latest official version ")+"("+version+").");
		   break;
		   case 2:
			QMessageBox::information(this,APPLICATION_NAME " " VERSION, tr("\nYou have the latest version of ")+ APPLICATION_NAME +".");
		   break;
		  default:
            QMessageBox::information(this,APPLICATION_NAME " " VERSION, tr("\nThere was an error when the version was checked."));
	     break;
	   };

   }


}


void CheckForUpdates::checkOnStart(std::string sprak)
{
    if (sprak == "sv_SE")
        applicationHomepage = APPLICATION_HOMEPAGE;
    else
        applicationHomepage = APPLICATION_HOMEPAGE_ENG;

    QUrl url(VERSION_PATH);
    QNetworkAccessManager *nam = new QNetworkAccessManager(this);

    reply = nam->get(QNetworkRequest(url));


    QObject::connect(nam, SIGNAL(finished(QNetworkReply*)),this, SLOT(checkForUpdatesOnStart(QNetworkReply*)));


}

void CheckForUpdates::checkForUpdatesOnStart(QNetworkReply *reply)
{
    QByteArray bytes = reply->readAll();  // bytes
    QString version = (QString) bytes; // string
    version = version.trimmed();


	 int ver = jfrVersion(version);
    if (ver == 0)
        QMessageBox::information(this,APPLICATION_NAME " " VERSION, tr("\nThere is a later version of ")+ APPLICATION_NAME +"<br>"+tr("Please download from")+"<p><a href=&quot;"+ applicationHomepage + "&quot;>" + applicationHomepage + "</a></p><p>"+tr("Latest version: ")+version+"</p>");





}

// private:

int CheckForUpdates::jfrVersion(QString version)
{
	int v, tv;
	bool ok;
	QString this_version(VERSION);
	QStringList l_this_version = this_version.split(".");
	QStringList l_version = version.split(".");
	for (int i=0;i<=2;i++)
	{
		v = l_version[i].toInt(&ok, 10);
		tv = l_this_version[i].toInt(&ok, 10);
		if (!ok)
			return 3;
		if (v>tv)
			return 0;
		if (v<tv)
			return 1;
    }

	return 2;
}

CheckForUpdates::~CheckForUpdates()
{
    delete this;
}
